/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.staat.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class StaatTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.String customCodeStaat;
    public java.lang.String getCustomCodeStaat(){
      return customCodeStaat;
    }
    protected final java.lang.String customCodeStaatsangehoerigkeit;
    public java.lang.String getCustomCodeStaatsangehoerigkeit(){
      return customCodeStaatsangehoerigkeit;
    }

  public StaatTK(
java.lang.String customCodeStaat
, java.lang.String customCodeStaatsangehoerigkeit
  ) {
    super();


      this.customCodeStaat = customCodeStaat;
      this.customCodeStaatsangehoerigkeit = customCodeStaatsangehoerigkeit;
    
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((customCodeStaat == null) ? 0 : customCodeStaat.hashCode());
                    result = result + ((customCodeStaatsangehoerigkeit == null) ? 0 : customCodeStaatsangehoerigkeit.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof StaatTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        StaatTK other = (StaatTK) obj;

                if (customCodeStaat == null) {
          if (other.customCodeStaat != null) {
            return false;
          }
        } else if (!customCodeStaat.equals(other.customCodeStaat)) {
          return false;
        }
                if (customCodeStaatsangehoerigkeit == null) {
          if (other.customCodeStaatsangehoerigkeit != null) {
            return false;
          }
        } else if (!customCodeStaatsangehoerigkeit.equals(other.customCodeStaatsangehoerigkeit)) {
          return false;
        }
        
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return StaatConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(StaatConstants.MESSAGE_KEY_ENTITY_EINZAHL, StaatConstants.MESSAGE_KEY_CODE_STAAT_EINZAHL, customCodeStaat));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(StaatConstants.MESSAGE_KEY_ENTITY_EINZAHL, StaatConstants.MESSAGE_KEY_CODE_STAATSANGEHOERIGKEIT_EINZAHL, customCodeStaatsangehoerigkeit));
        
        return result;
      }


            @Override
            public String toString() {
            return "StaatTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"customCodeStaat="+customCodeStaat
                            +", customCodeStaatsangehoerigkeit="+customCodeStaatsangehoerigkeit
                        
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(Messages messages) {
        return ""
                                      + messages.getMessageForMessageKey(StaatConstants.MESSAGE_KEY_CODE_STAAT_EINZAHL) + "=" + customCodeStaat
                          + ", " + messages.getMessageForMessageKey(StaatConstants.MESSAGE_KEY_CODE_STAATSANGEHOERIGKEIT_EINZAHL) + "=" + customCodeStaatsangehoerigkeit
                                             ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Staat> java.util.Map<StaatTK, E> mappeStaatNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Staat::getStaatTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Staat, StaatTK> getStaatToTKFunction() {
                return Staat::getStaatTK;
                }

}
